<%@page pageEncoding="UTF-8" errorPage="errorview.jsp"  import="java.util.*,com.highorbit.ServerAccessBean.*,
                                           com.highorbit.Course.*" contentType="text/html" %>

<%@ include file="include/pl_defaults.jsp" %>

<%

        if (session.getAttribute("sessionId")!=null){
            session.setAttribute("sessionId", null);
            session.setAttribute("company_name", null);
            session.setAttribute("currentUsername", null);
            response.sendRedirect("login.jsp");
        }
        String login_exception = "";
%>

<%@ include file="include/topdoc.jsp" %>
<%@ include file="include/ho_header.jsp" %>

<body bgcolor="#ffffff" >

<script type="text/javascript">
	jQuery(function(){
		jQuery('#username').focus();
		jQuery('#navbar').css("visibility", "hidden");
	});

	
</script>

<%

    String globalDtFmt      = "MM/dd/yyyy";
    String globalDtFmtLong  = "MM/dd/yyyy HH:mm z";

	String username 	= request.getParameter("username");
	String password 	= request.getParameter("password");
	String server 		= request.getParameter("server");
    String co_idstr     = request.getParameter("co_id");
	String serverportstr = request.getParameter("serverport");
	String redirURL 	= request.getParameter("redir");

    String token = null;

    if (request.getParameter("t") != null) {
        token = request.getParameter("t");
    }

    if (token != null) {
        serverportstr = request.getParameter("o");
        server = request.getParameter("s");
    }

    boolean bSecure = false;
    if (request.getServerPort() == 443) {
        bSecure = true;
    }

	if (redirURL != null)
        {
            redirURL = java.net.URLDecoder.decode(redirURL, "UTF-8");
        }
        else
            redirURL = "";

    int serverport  = 0;
    String server_str = "HighOrbit_production";
    
    String userPrincipal = null;
    
    if (request.getUserPrincipal() != null) {
    	userPrincipal = request.getUserPrincipal().getName();
    }


    int co_id = 0;
    if (co_idstr !=null && co_idstr.length() > 0)
    {
       try {
        co_id = Integer.parseInt(co_idstr);
       }
        catch(Exception e)
       {
           //ignore
       }
    }

    if (serverportstr != null && serverportstr.length() > 0)
    {
        if (serverportstr.endsWith("D") || serverportstr.endsWith("d"))
        {
           server_str = "HighOrbit_test";
           serverportstr = serverportstr.substring(0, serverportstr.length() - 1 );
        }
        try {
		    serverport = Integer.parseInt(serverportstr);
        } catch (Exception e) {
            //ignore
        }

    }


    if (serverportstr != null && server.length() > 0 && !sab.isConnected())
    {
        if (!sab.connect(server, serverport, server_str ))
        {
            response.sendRedirect( "notconnected.jsp" );
            return;
        }
        else
        {
            //save to session for later
            session.setAttribute("server", server);
            session.setAttribute("serverport", serverportstr);
			session.setAttribute("ServerAccessBean", sab);

				
			try {
				//save cookie for later
				Cookie serverCookie = new Cookie("server", server);
				serverCookie.setMaxAge(2419200);
				serverCookie.setPath("/");
				response.addCookie(serverCookie);
				Cookie portCookie = new Cookie("port", serverportstr);
				portCookie.setMaxAge(2419200);
				portCookie.setPath("/");
				response.addCookie(portCookie);
				Cookie companyCookie = new Cookie("company", co_idstr);
				companyCookie.setMaxAge(2419200);
				companyCookie.setPath("/");
				response.addCookie(companyCookie);
				Cookie userCookie = new Cookie("username", username);
				userCookie.setMaxAge(2419200);
				userCookie.setPath("/");
				response.addCookie(userCookie);
			} catch (IllegalArgumentException e) {
				// ignore cookie setting exceptions
			}
        }

    }

	String sessionId = "";
    boolean multiServer = true;
    
    //single signon ?
    if (userPrincipal != null) {
    	sab.connect(server, serverport, server_str);
    	sessionId = sab.ssoLogin(userPrincipal, 1, request.getRemoteAddr() );
    	if (sessionId == null)  sessionId = "0";
        if (sessionId.length() == 32) {
            int uid = sab.getMyUid(sessionId);
            UserInfo ui = sab.getUserInfo(sessionId, uid);
            session.setAttribute("timezone", TimeZone.getTimeZone(ui.getTimezone()));
            username = ui.getUsername();
            co_id = ui.getCoId();

            //find user's preferred date display format
            TreeMap prefs = sab.getUserPreferences(sessionId);
			String defDateFmt = globalDtFmt;
			String defDateFmtLong = globalDtFmtLong;
			if (prefs.containsKey("DATE_FORMAT")) {
				defDateFmt = (String)prefs.get("DATE_FORMAT");
			}
			if (prefs.containsKey("DATE_FORMAT_LONG")) {
				defDateFmtLong = (String)prefs.get("DATE_FORMAT_LONG");
			}
			if (prefs.containsKey("collapse")) {
				session.setAttribute("collapse", (String)prefs.get("collapse"));
			}
			
            session.setAttribute("dateformat", defDateFmt);
            session.setAttribute("dateformatlong", defDateFmtLong);
            
            
            session.setAttribute("username", username);
            session.setAttribute("password", "null");
            session.setAttribute("co_id", String.valueOf(co_id));

            //get company info
            CompanyInfo coInfo = sab.getCompanyInfo(sessionId, co_id);
            session.setAttribute("companyInfo", coInfo);
            session.setAttribute("sessionId", sessionId);
            session.setAttribute("company_name", sab.getCompanyName(sessionId));
            session.setAttribute("currentUsername", ui.getUsername());
            //check for disabled company
            if (coInfo.activeType == 0) {
                sab.logoffSession(sessionId);
                session.setAttribute("sessionId", null);
                response.sendRedirect( response.encodeRedirectURL("expired.jsp") );
            }
            //Hack: update stuff in next function TOO
            //check for demo expiration
            Date now = new Date();
            if (coInfo.activeType == 2 && now.after(coInfo.endDate)) {
                sab.logoffSession(sessionId);
                session.setAttribute("sessionId", null);
                response.sendRedirect( response.encodeRedirectURL("expired.jsp") );
            }
            //Account suspeneded?
            if (coInfo.activeType == 99) {
                sab.logoffSession(sessionId);
                session.setAttribute("sessionId", null);
                response.sendRedirect( response.encodeRedirectURL("suspended.jsp") );
            }
            //custom links?
            Vector cl = sab.getCustomLinks(sessionId);
            if (cl != null) {
                session.setAttribute("customlinks", cl);
            }

            String redir_form = request.getParameter("redir");
            if (redir_form != null && redir_form.length() > 0)
                response.sendRedirect( response.encodeRedirectURL(java.net.URLDecoder.decode(redir_form, "UTF-8")) );
            else
                //response.sendRedirect( response.encodeRedirectURL((String)session.getAttribute((String)session.getAttribute("page.initial"))) );
                response.sendRedirect( response.encodeRedirectURL("postlogin.jsp") );
            return;
        }
    }

    //try a token login
    if (token != null) {
        try {
            sessionId = sab.tokenLogin(token, request.getRemoteAddr());
        } catch (HoSecurityException e ) {
            //nothing
        }
        
        Locale.setDefault(sab.getServerLocale());
        
        out.print(sessionId);
        if (sessionId.length() == 32) {
            int uid = sab.getMyUid(sessionId);
            UserInfo ui = sab.getUserInfo(sessionId, uid);
            session.setAttribute("timezone", TimeZone.getTimeZone(ui.getTimezone()));
            username = ui.getUsername();
            co_id = ui.getCoId();

            //find user's preferred date display format
            TreeMap prefs = sab.getUserPreferences(sessionId);
			String defDateFmt = globalDtFmt;
			String defDateFmtLong = globalDtFmtLong;
			if (prefs.containsKey("DATE_FORMAT")) {
				defDateFmt = (String)prefs.get("DATE_FORMAT");
			}
			if (prefs.containsKey("DATE_FORMAT_LONG")) {
				defDateFmtLong = (String)prefs.get("DATE_FORMAT_LONG");
			}
			if (prefs.containsKey("collapse")) {
				session.setAttribute("collapse", (String)prefs.get("collapse"));
			}
			
            session.setAttribute("dateformat", defDateFmt);
            session.setAttribute("dateformatlong", defDateFmtLong);
            
            
            session.setAttribute("username", username);
            session.setAttribute("password", "null");
            session.setAttribute("co_id", String.valueOf(co_id));

            //get company info
            CompanyInfo coInfo = sab.getCompanyInfo(sessionId, co_id);
            session.setAttribute("companyInfo", coInfo);
            session.setAttribute("sessionId", sessionId);
            session.setAttribute("company_name", sab.getCompanyName(sessionId));
            session.setAttribute("currentUsername", ui.getUsername());
            //check for disabled company
            if (coInfo.activeType == 0) {
                sab.logoffSession(sessionId);
                session.setAttribute("sessionId", null);
                response.sendRedirect( response.encodeRedirectURL("expired.jsp") );
            }
            //Hack: update stuff in next function TOO
            //check for demo expiration
            Date now = new Date();
            if (coInfo.activeType == 2 && now.after(coInfo.endDate)) {
                sab.logoffSession(sessionId);
                session.setAttribute("sessionId", null);
                response.sendRedirect( response.encodeRedirectURL("expired.jsp") );
            }
            //Account suspeneded?
            if (coInfo.activeType == 99) {
                sab.logoffSession(sessionId);
                session.setAttribute("sessionId", null);
                response.sendRedirect( response.encodeRedirectURL("suspended.jsp") );
            }
            //custom links?
            Vector cl = sab.getCustomLinks(sessionId);
            if (cl != null) {
                session.setAttribute("customlinks", cl);
            }

            String redir_form = request.getParameter("redir");
            if (redir_form != null && redir_form.length() > 0)
                response.sendRedirect( response.encodeRedirectURL(java.net.URLDecoder.decode(redir_form, "UTF-8")) );
            else
                //response.sendRedirect( response.encodeRedirectURL((String)session.getAttribute((String)session.getAttribute("page.initial"))) );
                response.sendRedirect( response.encodeRedirectURL("postlogin.jsp") );
            return;
        } else {
            //out.println("e:"+sessionId);
        }
    }

	if (username != null)
	{
		session.setAttribute("username", username);
        session.setAttribute("password", password);
        session.setAttribute("co_id", String.valueOf(co_id));
        login_exception = "";
        try {
		    sessionId = sab.loginUser(username, password, co_id, request.getRemoteAddr());
		    Locale.setDefault(sab.getServerLocale());
		    
        } catch (HoSecurityException e) {
            if (e.isPasswordExpiredType()) {
                response.sendRedirect( "passwordresetexpired.jsp?t=" + e.getToken() );
            } else {
                login_exception = e.getMyMsg();
                if (e.url != null && e.url.length() > 0) {
                	 response.sendRedirect( response.encodeRedirectURL(e.url+"&username="+e.username+"&password="+e.password+"&co_id="+e.co_id) );
                }
            }
        }

		if (sessionId != null)
        {
			if (sessionId.length() == 32)
            {
                //get user's timezone info
                int uid = sab.getMyUid(sessionId);
                UserInfo ui = sab.getUserInfo(sessionId, uid);
                session.setAttribute("timezone", TimeZone.getTimeZone(ui.getTimezone()));

                //find user's preferred date display format
                TreeMap prefs = sab.getUserPreferences(sessionId);
    			String defDateFmt = globalDtFmt;
    			String defDateFmtLong = globalDtFmtLong;
    			if (prefs.containsKey("DATE_FORMAT")) {
    				defDateFmt = (String)prefs.get("DATE_FORMAT");
    			}
    			if (prefs.containsKey("DATE_FORMAT_LONG")) {
    				defDateFmtLong = (String)prefs.get("DATE_FORMAT_LONG");
    			}
                session.setAttribute("dateformat", defDateFmt);
                session.setAttribute("dateformatlong", defDateFmtLong);

				if (prefs.containsKey("collapse")) {
					session.setAttribute("collapse", (String)prefs.get("collapse"));
				}

                //more preferences for pages
                if (prefs.containsKey("page.tasklist")) {
                	session.setAttribute("page.tasklist", (String)prefs.get("page.tasklist"));
                }
                if (prefs.containsKey("page.taskdetail")) {
                	session.setAttribute("page.taskdetail", (String)prefs.get("page.taskdetail"));
                }
                if (prefs.containsKey("page.initial")) {
                	session.setAttribute("page.initial", (String)prefs.get("page.initial"));
                }
                if (prefs.containsKey("page.search")) {
                	session.setAttribute("page.search", (String)prefs.get("page.search"));
                }
                if (prefs.containsKey("page.dashboard")) {
                	session.setAttribute("page.dashboard", (String)prefs.get("page.dashboard"));
                }
                if (prefs.containsKey("page.help")) {
                	session.setAttribute("page.help", (String)prefs.get("page.help"));
                }
                if (prefs.containsKey("page.databasescan")) {
                	session.setAttribute("page.databasescan", (String)prefs.get("page.databasescan"));
                }
                if (prefs.containsKey("page.status")) {
                	session.setAttribute("page.status", (String)prefs.get("page.status"));
                }
                if (prefs.containsKey("page.user1")) {
                	session.setAttribute("page.user1", (String)prefs.get("page.user1"));
                }
                
                //get company info
                CompanyInfo coInfo = sab.getCompanyInfo(sessionId, co_id);
                session.setAttribute("companyInfo", coInfo);
				session.setAttribute("sessionId", sessionId);
                session.setAttribute("company_name", sab.getCompanyName(sessionId));
                session.setAttribute("currentUsername", ui.getUsername());
                //check for disabled company
                if (coInfo.activeType == 0) {
                    sab.logoffSession(sessionId);
                    session.setAttribute("sessionId", null);
                    response.sendRedirect( response.encodeRedirectURL("expired.jsp") );
                }
            //Hack: update stuff in previous function TOO
                //check for demo expiration
                Date now = new Date();
                if (coInfo.activeType == 2 && now.after(coInfo.endDate)) {
                    sab.logoffSession(sessionId);
                    session.setAttribute("sessionId", null);
                    response.sendRedirect( response.encodeRedirectURL("expired.jsp") );
                }
                //Account suspeneded?
                if (coInfo.activeType == 99) {
                    sab.logoffSession(sessionId);
                    session.setAttribute("sessionId", null);
                    response.sendRedirect( response.encodeRedirectURL("suspended.jsp") );
                }
                //custom links?
                Vector cl = sab.getCustomLinks(sessionId);
                if (cl != null) {
                    session.setAttribute("customlinks", cl);
                }

                String redir_form = request.getParameter("redir");
                if (redir_form != null && redir_form.length() > 0)
                    response.sendRedirect( response.encodeRedirectURL(java.net.URLDecoder.decode(redir_form, "UTF-8")) );
                else
                    //response.sendRedirect( response.encodeRedirectURL((String)session.getAttribute((String)session.getAttribute("page.initial"))) );
                    response.sendRedirect( response.encodeRedirectURL("postlogin.jsp") );
                return;
            } else {
                //out.println("s:"+sessionId);
            }
        }
     }

    //defaults with no cookies
    username = "";
    server = defaultServer;
    serverportstr = defaultPort;
    co_idstr = defaultCompany;

    //load values from cookie if available
	/*Cookie[] cookies = request.getCookies();
	if ( cookies != null )
	{
		for ( int i = 0; i < cookies.length; i++ )
		{
			if ( cookies[i].getName().equals("username") && username == null )
				username = cookies[i].getValue();
			else if ( cookies[i].getName().equals("server") && server == null )
				server = cookies[i].getValue();
			else if ( cookies[i].getName().equals("port") && serverportstr == null )
				serverportstr = cookies[i].getValue();
			else if ( cookies[i].getName().equals("company") && co_idstr == null )
				co_idstr = cookies[i].getValue();
		}
	}       */
        //override cookies if specified in url
        if (request.getParameter("u") != null)
            username = request.getParameter("u");
        if (request.getParameter("s") != null)
            server = request.getParameter("s");
        if (request.getParameter("o") != null)
            serverportstr = request.getParameter("o");
        if (request.getParameter("c") != null)
            co_idstr = request.getParameter("c");

%>
<br>
<form method="post" action="login.jsp?s=<%=server%>&o=<%=serverportstr%>&c=<%=co_id%>&u=<%=username%>&redir=<%=java.net.URLEncoder.encode(redirURL,"UTF-8")%>" id="form1" name="form1">
<%if (request.getParameter("cap") != null)
  {   %>
        <H3>  <%= request.getParameter("cap") %>  </H3>
<%}            %>

  <table border="0" width="400">
  

<%  if (server == null || server.length() == 0)
    {    %>
        <tr>

            <td class="fieldname">Server:</td>
			<td class="fields"><input name="server" value="<%= server %>" size="35"></td>
		</tr>
<%  }
    else
    {    %>
        <input type="hidden" name="server" value="<%= server %>">
<%  }
    if (serverportstr == null || serverportstr.length() == 0)
    {    %>
		<tr>
			<td class="fieldname">Port:</td>
			<td class="fields"><input name="serverport" value="<%= serverportstr %>" size="10" maxlength="5"></td>
		</tr>
<%  }
    else
    {    %>
        <input type="hidden" name="serverport" value="<%= serverportstr %>">
<%  }    %>

<%      if (multiServer && (co_idstr == null || co_idstr.length() == 0 || Integer.parseInt(co_idstr)==0))
        {  %>
    		<tr>
    			<td class="fields"><input name="co_id" value="110" type="hidden" size="5"></td>
    		</tr>
<%      }
        else
        { %>
            <input type="hidden" name="co_id" value="110">
<%      } %>
		<tr>
			<td class="fieldname">Username:</td>
			<td class="fields"><input id="username" name="username" value="<%= username %>" size="25"></td>
		</tr>
        <tr>
			<td class="fieldname">Password:</td>
			<td class="fields"><input name="password" type="password" value="" size="25"></td>
		</tr>
		<tr>
			<td class="fieldname">&nbsp;</td>
			<td class="fields">
			    <INPUT TYPE="image" alt="Submit" SRC="servlet/com.highorbit.Servlets.ButtonGeneratorServlet?text=Login&style=1&color=6699cc" value="Submit">
			</td>
		</tr>
		<% if (showPasswordHelp) {  %>
        <tr>
            <td class="fieldname">&nbsp;</td>
            <td class="fields">
                Forgot your <a href="forgot_username.jsp">Username</a> or <a href="forgot_password.jsp">Password</a>?
            </td>
        </tr>
        <% } %>
<%      if (showTrial) {        %>
            <tr><td class="fieldname" colspan="3">Need a free evaluation account?  <a target="_blank" href="http://www.highorbit.com/freetrial0.jsp">Sign up here</a>
            </td></tr>
<%      }%>
		</table>
		Your NT Login is passed as:  <%=userPrincipal %>   *** <%=sessionId%>
  <%
	if (login_exception.length() > 0)
	{
%>
  <h3><font color="#FF0000">Login Error:<%=login_exception%></font></h3>
<%
	}
%>
		</form>

<%  if (!bSecure && showSSL) {
    String myUrl = request.getRequestURI();
    if (request.getQueryString() != null && request.getQueryString().length() > 0)
       myUrl = myUrl + "?" +request.getQueryString();
%>
        <a href="https://<%=request.getServerName()%><%=myUrl%>">Secure/SSL Login</a>
        
<%
    }   %>
<!--Server:
<%=webServer%>
-->
<br>
<%@ include file="include/ho_footer.jsp" %>
